searchNodes=[{"doc":"An aggregate is the unit of business logic in the domain. The business logic is used to handle commands and also to apply events to change the aggregate state.This behaviour defines the callbacks for command execution and event application.","ref":"Incident.Aggregate.html","title":"Incident.Aggregate","type":"behaviour"},{"doc":"Receives a persisted event and the aggregate state, performing an aggregate state update.","ref":"Incident.Aggregate.html#c:apply/2","title":"Incident.Aggregate.apply/2","type":"callback"},{"doc":"Receives and executes the command, performing a specific business logic for it, usually considering the aggregate state as part of the logic.In case of a successful command and logic, a new event is composed and returned along with the aggregate state.In case of an unsuccessful command and logic, an error is returned containing a business logic reason.","ref":"Incident.Aggregate.html#c:execute/1","title":"Incident.Aggregate.execute/1","type":"callback"},{"doc":"Defines an Aggregate State macro that receives the aggregate module and an initial state.","ref":"Incident.AggregateState.html","title":"Incident.AggregateState","type":"module"},{"doc":"Defines the API for a Command.","ref":"Incident.Command.html","title":"Incident.Command","type":"behaviour"},{"doc":"Returns if a command is valid or not.","ref":"Incident.Command.html#c:valid?/1","title":"Incident.Command.valid?/1","type":"callback"},{"doc":"Defines a Command Handler that receives a command to:ensure that the command data is valid based on the command validations;executes the command using the aggregate;","ref":"Incident.CommandHandler.html","title":"Incident.CommandHandler","type":"module"},{"doc":"Defines the API for an Event Handler.","ref":"Incident.EventHandler.html","title":"Incident.EventHandler","type":"behaviour"},{"doc":"Listens to a persisted event and an aggregate state. You can use the aggregate to apply the persisted event and its state to get a new state, and to project new data into the projection store.","ref":"Incident.EventHandler.html#c:listen/2","title":"Incident.EventHandler.listen/2","type":"callback"},{"doc":"Defines the API to interact with the Event Store.The data source is based on the configured Event Store Adapter.","ref":"Incident.EventStore.html","title":"Incident.EventStore","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Incident.EventStore.html#child_spec/1","title":"Incident.EventStore.child_spec/1","type":"function"},{"doc":"","ref":"Incident.EventStore.html#start_link/1","title":"Incident.EventStore.start_link/1","type":"function"},{"doc":"Defines the API for an Event Store adapter.","ref":"Incident.EventStore.Adapter.html","title":"Incident.EventStore.Adapter","type":"behaviour"},{"doc":"Appends an event to the Event Store.","ref":"Incident.EventStore.Adapter.html#c:append/1","title":"Incident.EventStore.Adapter.append/1","type":"callback"},{"doc":"Receives an aggregate id and returns a list containing all persisted events from the Event Store.","ref":"Incident.EventStore.Adapter.html#c:get/1","title":"Incident.EventStore.Adapter.get/1","type":"callback"},{"doc":"Depending the adapter used to store the events, the persisted event will be defined by a different schema.","ref":"Incident.EventStore.Adapter.html#t:persisted_event/0","title":"Incident.EventStore.Adapter.persisted_event/0","type":"type"},{"doc":"Implements an in-memory Event Store using Agents.","ref":"Incident.EventStore.InMemory.Adapter.html","title":"Incident.EventStore.InMemory.Adapter","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Incident.EventStore.InMemory.Adapter.html#child_spec/1","title":"Incident.EventStore.InMemory.Adapter.child_spec/1","type":"function"},{"doc":"","ref":"Incident.EventStore.InMemory.Adapter.html#start_link/1","title":"Incident.EventStore.InMemory.Adapter.start_link/1","type":"function"},{"doc":"Defines the data structure for an aggregate lock for the in memory adapter.All fields are required.","ref":"Incident.EventStore.InMemory.AggregateLock.html","title":"Incident.EventStore.InMemory.AggregateLock","type":"module"},{"doc":"","ref":"Incident.EventStore.InMemory.AggregateLock.html#t:t/0","title":"Incident.EventStore.InMemory.AggregateLock.t/0","type":"type"},{"doc":"Defines the data structure for any event for the in memory adapter.All fields are required.","ref":"Incident.EventStore.InMemory.Event.html","title":"Incident.EventStore.InMemory.Event","type":"module"},{"doc":"","ref":"Incident.EventStore.InMemory.Event.html#t:t/0","title":"Incident.EventStore.InMemory.Event.t/0","type":"type"},{"doc":"Manages aggregate locks for the InMemory adapter.The Lock Manager can be configured during initialization for the retry logic and lock timeout.","ref":"Incident.EventStore.InMemory.LockManager.html","title":"Incident.EventStore.InMemory.LockManager","type":"module"},{"doc":"Attempts to acquire a lock for the aggregate id. It uses the lock manager configuration for retry logic. In case the lock can't be acquired after all retry attempts, it will return an error.","ref":"Incident.EventStore.InMemory.LockManager.html#acquire_lock/2","title":"Incident.EventStore.InMemory.LockManager.acquire_lock/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Incident.EventStore.InMemory.LockManager.html#child_spec/1","title":"Incident.EventStore.InMemory.LockManager.child_spec/1","type":"function"},{"doc":"Removes the lock for the aggregate id that belongs to the caller.","ref":"Incident.EventStore.InMemory.LockManager.html#release_lock/2","title":"Incident.EventStore.InMemory.LockManager.release_lock/2","type":"function"},{"doc":"","ref":"Incident.EventStore.InMemory.LockManager.html#start_link/1","title":"Incident.EventStore.InMemory.LockManager.start_link/1","type":"function"},{"doc":"","ref":"Incident.EventStore.InMemory.LockManager.html#t:aggregate_id/0","title":"Incident.EventStore.InMemory.LockManager.aggregate_id/0","type":"type"},{"doc":"","ref":"Incident.EventStore.InMemory.LockManager.html#t:config/0","title":"Incident.EventStore.InMemory.LockManager.config/0","type":"type"},{"doc":"","ref":"Incident.EventStore.InMemory.LockManager.html#t:lock_acquisition_response/0","title":"Incident.EventStore.InMemory.LockManager.lock_acquisition_response/0","type":"type"},{"doc":"Implements an Event Store using Postgres through Ecto.","ref":"Incident.EventStore.Postgres.Adapter.html","title":"Incident.EventStore.Postgres.Adapter","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Incident.EventStore.Postgres.Adapter.html#child_spec/1","title":"Incident.EventStore.Postgres.Adapter.child_spec/1","type":"function"},{"doc":"","ref":"Incident.EventStore.Postgres.Adapter.html#repo/0","title":"Incident.EventStore.Postgres.Adapter.repo/0","type":"function"},{"doc":"","ref":"Incident.EventStore.Postgres.Adapter.html#start_link/1","title":"Incident.EventStore.Postgres.Adapter.start_link/1","type":"function"},{"doc":"Defines the data structure for an aggregate lock for the Postgres adapter.All fields are required.","ref":"Incident.EventStore.Postgres.AggregateLock.html","title":"Incident.EventStore.Postgres.AggregateLock","type":"module"},{"doc":"","ref":"Incident.EventStore.Postgres.AggregateLock.html#t:t/0","title":"Incident.EventStore.Postgres.AggregateLock.t/0","type":"type"},{"doc":"Defines the data structure for any event for the Postgres adapter.All fields are required.","ref":"Incident.EventStore.Postgres.Event.html","title":"Incident.EventStore.Postgres.Event","type":"module"},{"doc":"","ref":"Incident.EventStore.Postgres.Event.html#t:t/0","title":"Incident.EventStore.Postgres.Event.t/0","type":"type"},{"doc":"Manages aggregate locks for the Postgres adapter.The Lock Manager can be configured during initialization for the retry logic and lock timeout.","ref":"Incident.EventStore.Postgres.LockManager.html","title":"Incident.EventStore.Postgres.LockManager","type":"module"},{"doc":"Attempts to acquire a lock for the aggregate id. It uses the lock manager configuration for retry logic. In case the lock can't be acquired after all retry attempts, it will return an error.","ref":"Incident.EventStore.Postgres.LockManager.html#acquire_lock/2","title":"Incident.EventStore.Postgres.LockManager.acquire_lock/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Incident.EventStore.Postgres.LockManager.html#child_spec/1","title":"Incident.EventStore.Postgres.LockManager.child_spec/1","type":"function"},{"doc":"Removes the lock for the aggregate id that belongs to the caller.","ref":"Incident.EventStore.Postgres.LockManager.html#release_lock/2","title":"Incident.EventStore.Postgres.LockManager.release_lock/2","type":"function"},{"doc":"","ref":"Incident.EventStore.Postgres.LockManager.html#start_link/1","title":"Incident.EventStore.Postgres.LockManager.start_link/1","type":"function"},{"doc":"","ref":"Incident.EventStore.Postgres.LockManager.html#t:aggregate_id/0","title":"Incident.EventStore.Postgres.LockManager.aggregate_id/0","type":"type"},{"doc":"","ref":"Incident.EventStore.Postgres.LockManager.html#t:config/0","title":"Incident.EventStore.Postgres.LockManager.config/0","type":"type"},{"doc":"","ref":"Incident.EventStore.Postgres.LockManager.html#t:lock_acquisition_response/0","title":"Incident.EventStore.Postgres.LockManager.lock_acquisition_response/0","type":"type"},{"doc":"Defines the API to interact with the Projection Store.The data source is based on the configured Projection Store Adapter.","ref":"Incident.ProjectionStore.html","title":"Incident.ProjectionStore","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Incident.ProjectionStore.html#child_spec/1","title":"Incident.ProjectionStore.child_spec/1","type":"function"},{"doc":"","ref":"Incident.ProjectionStore.html#start_link/1","title":"Incident.ProjectionStore.start_link/1","type":"function"},{"doc":"Defines the API for a Projection Store adapter.","ref":"Incident.ProjectionStore.Adapter.html","title":"Incident.ProjectionStore.Adapter","type":"behaviour"},{"doc":"Returns all projections from a specific projection type from the Projection Store.","ref":"Incident.ProjectionStore.Adapter.html#c:all/1","title":"Incident.ProjectionStore.Adapter.all/1","type":"callback"},{"doc":"Returns a projection record from a specific projection type from the Projection Store.","ref":"Incident.ProjectionStore.Adapter.html#c:get/2","title":"Incident.ProjectionStore.Adapter.get/2","type":"callback"},{"doc":"Insert or updates a projection in the Projection Store.Receives the projection type and the data for the projection.","ref":"Incident.ProjectionStore.Adapter.html#c:project/2","title":"Incident.ProjectionStore.Adapter.project/2","type":"callback"},{"doc":"Implements an in-memory Projection Store using Agents.","ref":"Incident.ProjectionStore.InMemory.Adapter.html","title":"Incident.ProjectionStore.InMemory.Adapter","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Incident.ProjectionStore.InMemory.Adapter.html#child_spec/1","title":"Incident.ProjectionStore.InMemory.Adapter.child_spec/1","type":"function"},{"doc":"","ref":"Incident.ProjectionStore.InMemory.Adapter.html#start_link/1","title":"Incident.ProjectionStore.InMemory.Adapter.start_link/1","type":"function"},{"doc":"Implements a Projection Store using Postgres through Ecto.","ref":"Incident.ProjectionStore.Postgres.Adapter.html","title":"Incident.ProjectionStore.Postgres.Adapter","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Incident.ProjectionStore.Postgres.Adapter.html#child_spec/1","title":"Incident.ProjectionStore.Postgres.Adapter.child_spec/1","type":"function"},{"doc":"","ref":"Incident.ProjectionStore.Postgres.Adapter.html#start_link/1","title":"Incident.ProjectionStore.Postgres.Adapter.start_link/1","type":"function"},{"doc":"This task will generate some basic setup when using PostgresAdapter.When using this adapter you will need to have a table to store the events and aggregate locks. This task will generate an Ecto migration to create the events and aggregate_locks table with the needed columns and indexes. The task will respect your Ecto configuration for your EventStoreRepo.Usagemix incident.postgres.init -r AppName.EventStoreRepo","ref":"Mix.Tasks.Incident.Postgres.Init.html","title":"Mix.Tasks.Incident.Postgres.Init","type":"task"},{"doc":"IncidentEvent Sourcing and CQRS building blocks.Special thanks to my friend Paulo Gonzalez for the name suggestion for this library.This library is in constant development phase and evaluation, that means core changes still can be made. While I am already using Incident in production, please be advised about the risks, once the library reaches its maturity, a release 1.x.x will be created.","ref":"readme.html","title":"Incident","type":"extras"},{"doc":"incentivize the usage of Event Sourcing and CQRS as good choice for domains that can leverage the main benefits of this design pattern;offer the essential building blocks for using Event Sourcing in your system with proper contracts, but allowing specific needs to leverage what Elixir already brings to the table, for example, concurrency;leverage functions and reducers for executing commands and applying events, facilitating stateless tests;allow customization for fine-grained needs without compromising the principles;","ref":"readme.html#goals","title":"Incident - Goals","type":"extras"},{"doc":"Example ApplicationThere is an example application that implements a Bank application for reference with great documentation and including all the details and usage in IEx as well.It also contains projections specific to the application domain with migration and schemas defined.This example application will give you all the details in how to use Incident, including integration tests for both InMemory and Postgres adapters for both Event Store and Projection Store.Blog PostsUsing Event Sourcing and CQRS with Incident - Part 1","ref":"readme.html#getting-started","title":"Incident - Getting Started","type":"extras"},{"doc":"In a nutshell, Event Sourcing ensures that all changes to application state are stored as a sequence of events. But if you are new to Event Sourcing and CQRS I highly recommend watch Greg Young's presentation at Code on the Beach 2014 before moving forward.","ref":"readme.html#event-sourcing-and-cqrs","title":"Incident - Event Sourcing and CQRS","type":"extras"},{"doc":"CommandIt is a data structure used to define the command attributes with some basic validation.Command HandlerIt is the entry point of a command in the write side. It performs basic command validation and executes the command through the Aggregate logic.AggregateDefines how a specific entity (User, for example) in your domain will execute each of its commands and apply each of its events. The aggregate itself only defines the logic but not its state.Aggregate StateDefines the initial state of an Aggregate and it is able to calculate the new state by replaying all the events through the aggregate logic.EventIt is a data structure that defines the event data attributes.Event HandlerReceives a persisted event and perform actions in the read side such as to update the projection for an individual aggregate. Another usage is to build a new command and send to the Command Hanlder when specific events should trigger a new cycle.ProjectionIt represents the current state of an individual aggregate (User ID: 123456, for example) after replaying all events. Your application reads/queries data from the projection, that is similar to a persisted cache.Event StoreAll events from all aggregates are stored in the Event Store. The Event Store uses the Port/Adapter design pattern so through configuration you can define which adapter your application will use to store the events. Currently, Incident comes with two adapters, an InMemory to be used as playground and a Postgres one.Projection StoreVery similar to the Event Store, the Projection Store uses the Port/Adapter design pattern so through configuration you can define which adapter your application will use to store the aggregate projections. Currently, Incident comes with two adapters, an InMemory to be used as playground and a Postgres one.","ref":"readme.html#main-components","title":"Incident - Main Components","type":"extras"},{"doc":"If available in Hex, the package can be installed by adding incident to your list of dependencies in mix.exs:def deps do [ {:incident, &quot;~&gt; 0.6.0&quot;} ] end","ref":"readme.html#installation","title":"Incident - Installation","type":"extras"},{"doc":"Incident will be added as part of the application supervision tree, configuring the the adapters for the Event Store and the Projection Store.With Postgres AdaptersThe Postgres adapter uses Ecto behind the scenes so a lot of its configuration it is simply how you should configure a Postgres database for any application using Ecto.There will be two Ecto Repos, one for the events and another one for the projections.Optionally, you can even define two different databases, so the events database will contain only one table (events) and the projections database will contain one table fore each projection type.Add the Ecto Repo modules for both databases:defmodule AppName.EventStoreRepo do use Ecto.Repo, otp_app: :app_name, adapter: Ecto.Adapters.Postgres end defmodule AppName.ProjectionStoreRepo do use Ecto.Repo, otp_app: :app_name, adapter: Ecto.Adapters.Postgres end In your application config.exs specify the repositories:config :app_name, ecto_repos: [AppName.EventStoreRepo, AppName.ProjectionStoreRepo]In your application dev|test|prod.exs (the example below defines two databases but it could be only one):config :app_name, AppName.EventStoreRepo, username: &quot;postgres&quot;, password: &quot;postgres&quot;, hostname: &quot;localhost&quot;, database: &quot;app_name_event_store_dev&quot; config :app_name, AppName.ProjectionStoreRepo, username: &quot;postgres&quot;, password: &quot;postgres&quot;, hostname: &quot;localhost&quot;, database: &quot;app_name_projection_store_dev&quot;Create the application databases running the Ecto mix task:mix ecto.createUse the Incident Mix Task below to generate the events and aggregate_locks table migrations, after that, run the migration task:mix incident.postgres.init -r AppName.EventStoreRepo mix ecto.migrateThe migrations and schemas for the projections will depend on your application domains and it follows the same process for any Ecto Migration.Add Incident in the application.ex, adding into the application supervision tree:defmodule AppName.Application do @moduledoc false use Application def start(_type, _args) do config = %{ event_store: %{ adapter: :postgres, options: [repo: AppName.EventStoreRepo] }, projection_store: %{ adapter: :postgres, options: [repo: AppName.ProjectionStoreRepo] } } children = [ AppName.EventStoreRepo, AppName.ProjectionStoreRepo, {Incident, config} ] opts = [strategy: :one_for_one, name: AppName.Supervisor] Supervisor.start_link(children, opts) end endWith InMemory AdaptersIn case of InMemory adapters that use Agent there is no need for any Ecto configuration so it is simply addedIncident to the application supervision tree:defmodule AppName.Application do @moduledoc false use Application def start(_type, _args) do config = %{ event_store: %{ adapter: :in_memory, options: [] }, projection_store: %{ adapter: :in_memory, options: [ initial_state: %{AppName.Projections.ProjectionName =&gt; []} ] } } children = [ {Incident, config} ] opts = [strategy: :one_for_one, name: AppName.Supervisor] Supervisor.start_link(children, opts) end end","ref":"readme.html#usage","title":"Incident - Usage","type":"extras"},{"doc":"The list below is the upcoming enhacements or fixes, it will grow as the library is being developed.[ ] allow Incident to be used by more than one application within the umbrella, if needed;[ ] add Telemetry module and trigger telemetry events;[ ] run migrations when using mix incident.postgres.init for Postgres adapter;[ ] allow custom error modules to be used and incorporate as part of the contract in some components;","ref":"readme.html#planned-next-steps","title":"Incident - Planned Next Steps","type":"extras"},{"doc":"We appreciate any contribution to Incident. Please see the Code of Conduct and Contributing guides.","ref":"readme.html#contributing","title":"Incident - Contributing","type":"extras"},{"doc":"The full documentation can be found at https://hexdocs.pm/incident.","ref":"readme.html#documentation","title":"Incident - Documentation","type":"extras"}]